#include <EEPROM_Rotate.h>
EEPROM_Rotate EEPROMr;
#define DATA_OFFSET     10

void setup() {
  Serial.begin(115200);
  delay(2000);

  EEPROMr.size(4);
  EEPROMr.begin(4096);


 // Save string to flash memory (EEPROM library). Try to comment this line after the first run.
//Serial.print("Writing string: ");
//String input_string = "Test string to store in flash memory";
//Serial.println(input_string);
//writeString(input_string,0);


 // Read data from flash memory (EEPROM library)
  Serial.print("Reading string: ");
  String output_string = readString(0);
  Serial.println(output_string);   

}

// Set 'pos' parameter to specify begin position of the string in memory 
void writeString(String str, int pos){
  for (int i=0; i<str.length(); i++) {
    int s = str[i];
    EEPROMr.write(i+pos+DATA_OFFSET, s);
  }
  EEPROMr.write(str.length()+pos+DATA_OFFSET,'\0');
  EEPROMr.commit();
}

// Set 'pos' parameter to specify begin position of the string in memory
String readString(int pos){
  char data[100]; // Max 100 Bytes
  int len = 0;
  unsigned char k;
  while(k != '\0' && len <= 100){
    k = char(EEPROMr.read(len+pos+DATA_OFFSET));
    data[len] = k;
    len++;
  }
  return String(data);
}

void loop() {
  delay(1000);
}
